package gregapi.tileentity.cover;

import gregapi.code.ItemStackContainer;
import gregapi.code.ItemStackMap;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;

/**
 * @author Gregorius Techneticies
 */
public class CoverRegistry {
	public static ItemStackMap<ItemStackContainer, ICover> COVERS = new ItemStackMap<ItemStackContainer, ICover>();
	
	public static ICover get(short aID, short aMetaData) {
		return COVERS.get(aID, aMetaData);
	}
	
	public static ICover get(ItemStack aStack) {
		return aStack==null?null:get(UT.Stacks.id(aStack), UT.Stacks.meta(aStack));
	}
	
	public static void put(ItemStackContainer aStack, ICover aCover) {
		if (aStack != null && UT.Stacks.valid(aStack.toStack())) COVERS.put(aStack, aCover);
	}
	
	public static void put(ItemStack aStack, ICover aCover) {
		put(new ItemStackContainer(aStack), aCover);
	}
	
	public static void put(Item aItem, long aMetaData, ICover aCover) {
		put(new ItemStackContainer(aItem, 1, aMetaData), aCover);
	}
	
	public static void put(Block aBlock, long aMetaData, ICover aCover) {
		put(new ItemStackContainer(aBlock, 1, aMetaData), aCover);
	}
	
	public static CoverData coverdata(ITileEntityCoverable aTileEntity, NBTTagCompound aNBT) {
		return aNBT == null ? new CoverData(aTileEntity) : new CoverData(aTileEntity, aNBT);
	}
}